Index: stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 13636)
+++ stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 13973)
@@ -196,4 +196,5 @@
     <Compile Include="Regression\RealWorld\Housing.cs" />
     <Compile Include="Regression\RealWorld\RealWorldRegressionInstanceProvider.cs" />
+    <Compile Include="Regression\RealWorld\SARCOS.cs" />
     <Compile Include="Regression\RealWorld\Tower.cs" />
     <Compile Include="Regression\RegressionDataDescriptor.cs" />
Index: stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs
===================================================================
--- stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 13636)
+++ stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 13973)
@@ -51,4 +51,5 @@
       descriptorList.Add(new Tower());
       descriptorList.Add(new Powermeter());
+      descriptorList.Add(new SARCOS());
       var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
       if (!String.IsNullOrEmpty(solutionsArchiveName)) {
Index: stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs
===================================================================
--- stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs	(revision 13973)
+++ stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs	(revision 13973)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class SARCOS : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "SARCOS - Inverse Dynamics"; } }
+    public override string Description {
+      get {
+        return "Publication: Rasmussen and Williams: Gaussian Processes for Machine Learing" + Environment.NewLine +
+               "Link: http://www.gaussianprocess.org/gpml/data/";
+      }
+    }
+    protected override string TargetVariable { get { return "y1"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "x17", "x18", "x19", "x20", "x21", "y1", "y2", "y3", "y4", "y5", "y6", "y7" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "x17", "x18", "x19", "x20", "x21" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 44484; } }
+    protected override int TestPartitionStart { get { return 44484; } }
+    protected override int TestPartitionEnd { get { return 48933; } }
+  }
+}